with(DEtools):

MinOp := proc(f, yx)
	local Dx, x, dseq, eqn, a, i, N, indeterms, co, ans;
	if nargs = 2 then
		if not type(yx, function) then
			error "Second argument should be the dependent variable"
		else
			_Envdiffopdomain := [Dx, op(1, yx)];
			return diffop2de(procname(f), yx)
		fi
	elif nargs = 1 then
		if assigned(_Envdiffopdomain) then
			Dx,x := op(_Envdiffopdomain)
		else
			error "Need to give a second argument or assign _Envdiffopdomain"
		fi
	fi;

	if f=0 then
		return 1
	elif not has(f,x) then
		return Dx
	elif type(f,`^`) and type(op(2,f), posint) then
		return symmetric_power(procname(op(1,f)), op(2,f))
	elif has(f, Int) then
		if type(f,function) and op(0,f)=Int then
			return collect(procname(op(1,f))*Dx,Dx)
		elif type(f,`+`) then
			a := [op(f)];
			return LCLM(seq(`if`(has(i,Int),procname(i),NULL), i=a), procname(add(`if`(has(i,Int),0,i), i=a)))
		elif type(f,`*`) then
			a := [op(f)];
			return symmetric_product(seq(`if`(has(i,Int),procname(i),NULL), i=a), procname(mul(`if`(has(i,Int),1,i), i=a)))
		fi
	fi;

	if not assigned(_Env_MinOp_MAX_SEARCH) then
		_Env_MinOp_MAX_SEARCH := 6
	fi;
	dseq := simplify(f);
	for N from 1 to _Env_MinOp_MAX_SEARCH do
		dseq := dseq, simplify(evala(diff([dseq][-1],x)));
		eqn := simplify(add(a[i]*dseq[i+1], i=0..(N-1)) + dseq[N+1]);
		indeterms := indets(eqn,function);
		co := SolveTools:-Linear({coeffs(collect(eqn,indeterms,'distributed'),indeterms)}, {seq(a[i],i=0..N-1)});
		if co<>NULL then
			ans := eval(add(a[i]*Dx^i, i=0..(N-1)) + Dx^N, co);
			return sort(collect(ans, Dx, proc(a) factor(normal(a,expanded)) end), Dx)
		fi;
	od;
	WARNING("It might help to assign _Env_MinOp_MAX_SEARCH := an integer larger than six;");
	FAIL
end:


